using Microsoft.IdentityModel.Clients.ActiveDirectory;
using System;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Net;
using System.IO;
using Newtonsoft.Json;

namespace Forms
{
    public class Auth
    {
        // Office 365 Logon(e.g. https://login.microsoftonline.com)
        public static string AADInstance
        {
            get { return "https://login.microsoftonline.com"; }
        }

        // The Office 365 domain (e.g. contoso.microsoft.com)
        public static string Domain
        {
            get { return "OurTenantName.onmicrosoft.com"; }
        }

        // The authority for authentication; combining the AADInstance
        // and the domain.
        public static string Authority
        {
            get { return string.Format("{0}/{1}/", AADInstance, Domain); }
        }

        // The client Id of your native Azure AD application
        public static string ClientId
        {
            get { return "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"; }
        }

        // The redirect URI specified in the Azure AD application
        public static Uri RedirectUri
        {
            get { return new Uri("http://localhost:00000/"); }
        }

        // The resource identifier for the Microsoft Graph
        public static string GraphResource
        {
            get { return "https://graph.microsoft.com/"; }
        }

        // The Microsoft Graph version, can be "v1.0" or "beta"
        public static string GraphVersion
        {
            get { return "v1.0"; }
        }

        public static AuthenticationContext authContext = null;
        public static AuthenticationResult authResult = null;
        public static HttpClient httpClient = null;

        public static string signInResult;

        public static Task SignIn()
        {
            return Task.Run(async () =>
            {
                authContext = new AuthenticationContext(Authority);

                try
                {
                    authResult  = await authContext.AcquireTokenAsync(GraphResource, ClientId, RedirectUri, new PlatformParameters(PromptBehavior.Always, null));

                }
                catch (AdalException ex)
                {
                    
                }
                    return;                
            });
        }

        public static HttpClient GetHttpClient(string accessToken)
        {
            // Create the HTTP client with the access token
            var httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", accessToken);
            return httpClient;
        }

        public static string userResponse = null;
        public static Task GetUser(HttpClient httpClient, string username)
        {
            return Task.Run(async () =>
            {
                userResponse = await httpClient.GetStringAsync(GraphResource + GraphVersion + "/users/" + username);

            });
        }
    }
}